
CaptureSelector selector;
Capture prev_cap;

void setup() {
  size(400, 300);
  selector = new CaptureSelector(this);
  selector.show();
}

void draw() {
  // get capture
  Capture cap = selector.getCapture();
  if ( cap==null || !cap.available() ) return;
    
  // change window size when the configuration is updated
  if ( cap != prev_cap ) {
    Insets insets = frame.getInsets();
    cap.read();
    size(cap.width, cap.height);
    frame.setSize( cap.width + insets.left + insets.right, cap.height + insets.top + insets.bottom );
  }

  // draw captured image
  background(0);
  cap.read();
  image(cap, 0, 0);

  // update previous info
  prev_cap = cap;
}

void mousePressed() {
  // show capture selector window
  selector.show();
}
